<template>
  <div :id="id" :class="{ modal: true, fade: true, show: show }" :style="`display: ${show ? 'block' : 'none'};`">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h4 class="modal-title" v-if="title">{{ title }}</h4>
          <button type="button" class="btn-close" :disabled="!dismisable" @click="onClickClose">&times;</button>
        </div>
        <div class="modal-body">
          <slot></slot>
        </div>
        <div class="modal-footer" v-if="hasVisibleButtons">
          <button
            type="button"
            v-for="button in visibleButtons"
            :key="button.id"
            :id="button.id"
            :class="button.class"
            :disabled="button.disabled"
            @click="onClick"
          >
            <i aria-hidden="true" :class="button.iconClass" v-if="button.iconClass"></i>
            {{ button.text }}
          </button>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import { computed, toRef } from 'vue'
import ValidationHelper from '../lib/validation-helper.js'

export default {
  name: 'ModalWindow',
  emits: ['button'],
  props: {
    id: { type: String, required: true },
    title: { type: String, default: '' },
    buttons: {
      type: Array,
      default() {
        return []
      },
    },
    dismisable: { type: Boolean, default: true },
    moveToBottom: { type: Boolean, default: false },
    show: { type: Boolean, default: false },
  },
  setup(props, context) {
    const buttonsAsRef = toRef(props, 'buttons')

    const visibleButtons = computed(() => buttonsAsRef.value.filter((b) => b.visible))

    const hasVisibleButtons = computed(() => {
      return !ValidationHelper.arrayIsEmpty(visibleButtons.value)
    })

    const onClickClose = () => {
      context.emit('button', 'close')
    }

    const onClick = (event) => {
      const button = event.target.closest('button')
      context.emit('button', button.getAttribute('id'))
    }

    return {
      visibleButtons,
      hasVisibleButtons,
      onClickClose,
      onClick,
    }
  },
}
</script>
